require('./../css/reset.css');
require('./../css/indexHorizontal.less');
// require('./../css/popup.css');
// require('./popupEdit.js');
var Promise = require("bluebird");
let warningImg = require('./../images/warings.png')
let diagImg = require('./../images/yszd.png')
let symptomImg = require('./../images/inquire.png')
let physiExamImg = require('./../images/tgjc.png')
let labAndPacsImg = require('./../images/inspect.png')
let conditTipsImg = require('./../images/tips.png')
let treatImg = require('./../images/zhiliao.png')

const $ = require("jquery");
const { post,config,getUrlArgObject,openNewWin, isIe8 } = require('./promise.js');
const { transConf } = require('./util.js');
const { renderRecommendInfo, renderMultRecommendInfo, renderTreat, renderRecommendConditTips, renderTipsInfo ,renderKnowledgeInfo,renderScaleInfo} = require('./indexHorizontalDom.js');
const is8Ie = isIe8() //判断是否为IE8
if(is8Ie) {
  let reg = /undefined/g
  warningImg = warningImg.replace(reg, '')
  diagImg = diagImg.replace(reg, '')
  symptomImg = symptomImg.replace(reg, '')
  physiExamImg = physiExamImg.replace(reg, '')
  labAndPacsImg = labAndPacsImg.replace(reg, '')
  conditTipsImg = conditTipsImg.replace(reg, '')
  treatImg = treatImg.replace(reg, '')
}

let mrId = getUrlArgObject('mrId') 
let showTab = getUrlArgObject('showTab') || '0';
let msg;
if(mrId) {
 post(config.getMr,{mrId:mrId}).then((res) => {
    const data = res.data
    if(data.code == 0) {
      msg = Object.assign(data.data, {hosCode:getUrlArgObject('hospitalCode') || '',plan:getUrlArgObject('plan') || '0',})
      window.msg = msg
      getPageInfo();
    }
  })
} else {
  msg = {
    age: getUrlArgObject('age'),
    sex: getUrlArgObject('sex') == '男'?1:(getUrlArgObject('sex') == '女'?2:(getUrlArgObject('sex') == '通用'?3:getUrlArgObject('sex'))),
    symptom: getUrlArgObject('symptomJson'),
    vital: getUrlArgObject('vitalJson'),
    lis: getUrlArgObject('lisJson')? JSON.parse(getUrlArgObject('lisJson')) : [],
    pacs: getUrlArgObject('pacsJson'),
    diag: getUrlArgObject('diagJson'),
    diseaseName: getUrlArgObject('diseaseName'),
    other: getUrlArgObject('otherJson') + getUrlArgObject('pastJson'),
    hosCode:getUrlArgObject('hospitalCode') || '',
    plan:getUrlArgObject('plan') || '0',
  }
  window.msg = msg
  getPageInfo();
}


// var msg = {
//     age: getUrlArgObject('age'),
//     sex: getUrlArgObject('sex') == '男'?1:(getUrlArgObject('sex') == '女'?2:(getUrlArgObject('sex') == '通用'?3:getUrlArgObject('sex'))),
//     symptom: getUrlArgObject('symptomJson'),
//     vital: getUrlArgObject('vitalJson'),
//     lis: getUrlArgObject('lisJson')? JSON.parse(getUrlArgObject('lisJson')) : [],
//     pacs: getUrlArgObject('pacsJson'),
//     diag: getUrlArgObject('diagJson'),
//     diseaseName: getUrlArgObject('diagJson'),
//     other: getUrlArgObject('otherJson') + getUrlArgObject('pastJson'),
//     hosCode:getUrlArgObject('hospitalCode') || '',
//     plan:getUrlArgObject('plan') || '0',
// }//推送相关信息
// //   http://localhost:8082/indexVert.html?age=28&diseaseId=280&lisJson=&diagJson=%E6%80%A5%E6%80%A7%E8%83%B0%E8%85%BA%E7%82%8E&pastJson=%E6%97%A0%E5%BF%83%E8%84%8F%E7%97%85&otherJson=%E6%97%A0%E9%AB%98%E8%A1%80%E5%8E%8B&pacsJson=%E8%85%B9%E9%83%A8B%E8%B6%85:%E6%97%A0%E5%BC%82%E5%B8%B8,%20%E6%8A%A5%E5%91%8A%E6%97%A5%E6%9C%9F:2019-05-07&sex=%E7%94%B7&symptomJson=%E6%81%B6%E5%BF%83%E5%91%95%E5%90%90%E8%85%B0%E7%97%9B&vitalJson=%E8%A1%80%E5%8E%8B%E5%B7%A6%E4%B8%8A%E8%82%A213/12mmHg
// window.msg = msg
// window.pushMessage = {}
function getConf() {
  return post(config.getSysSetInfoDatas,{hospitalCode: msg.hosCode,plan:msg.plan})
}

function getPushInfo() {
  return post(config.pushInner,Object.assign({featureType: '1,4,5,6,7,22'},msg))
}

function getTreatment() {
  return post(config.pushTreatment,Object.assign({featureType: '8'},msg))
}


function getTipsInfo() {
  let tipsInfoList =  getUrlArgObject('tipsInfoList')&&JSON.parse(getUrlArgObject('tipsInfoList')) || []
  return post(config.informationMore, {conceptIntorduces:tipsInfoList})
  // return post(config.information,{name:getUrlArgObject('tipsName'),type:getUrlArgObject('tipsType'), position: 1})
}

function getPageInfo() {
  Promise.all([getConf(),getPushInfo(),getTreatment(),getTipsInfo()]).then(([res1, res2, res3,res4]) =>{
    const configArr = res1&&res1.data&&res1.data.data || []
    const pushInfo = res2.data || {}
    const treatInfo = res3.data || {}
    const tipsInfo = res4.data || []
    const confArr = transConf(configArr)
    pushResult = pushInfo.data || {};
    treatResult = treatInfo.data || {}
    tipsResult = tipsInfo.data || {}
    
    const diagPossible =  pushResult.dis&&pushResult.dis['可能诊断'] || []//可能
    const diagDoubt = pushResult.dis&&pushResult.dis['拟诊'] || [] // 疑似
    const diagDeter = pushResult.dis&&pushResult.dis['确诊'] || []//确诊
    const diagWaring = pushResult.dis&&pushResult.dis['警惕'] || [] // 推荐警惕诊断
    const symptomRecommend = pushResult.symptom || []  //推荐问诊症状
    const physiExamRecommend  = pushResult.vital || [] //推荐体格检查
    const diagRecommend = diagDeter.concat(diagDoubt, diagPossible) //推荐诊断
    const labRecommend = pushResult.lab || []
    const pacsRecommend = pushResult.pacs || []
    const medicalIndications = pushResult.medicalIndications || []
    const labAndPacsRecommend = [
      {
          title: '化验',
          className: 'labRecommend',
          data:  labRecommend
      },
      {
          title: '辅检',
          className: 'pacsRecommend',
          data:  pacsRecommend
      }
    ]
    window.pushMessage = medicalIndications;//计算的需要的相关数据
    let tipsNum = 0;
    for(let i = 0; i < confArr.length; i++) {
      switch(confArr[i].code) {
        case "inquiry_show":  //问诊症状
          renderRecommendInfo(symptomImg, 'symptomRecommend', '问诊症状', symptomRecommend, false)
          break; 
        case "health_show": //体格检查
          renderRecommendInfo(physiExamImg, 'physiExamRecommend', '体格检查', physiExamRecommend, false)
          break;
        case "illness_show": //病情提示
          renderRecommendConditTips(conditTipsImg, 'conditTips','病情提示', medicalIndications || [])
          break;
        case "vigilant_show": //警惕诊断
          renderRecommendInfo(warningImg, 'warning', '警惕诊断', diagWaring, true,7,2)
          break;
        case "lispacs_show": //检验检查
          renderMultRecommendInfo(labAndPacsImg, 'labAndPacsRecommend', '检验检查', labAndPacsRecommend, false)
          break;
        case "cure_show": //治疗方案
          tipsNum++;
          renderTreat(treatImg, 'treatRecommend','治疗方案',treatResult)
          break;
        case "diagnose_show": //推荐诊断
          renderRecommendInfo(diagImg, 'diagRecommend', '推荐诊断', diagRecommend, true,7,2)
          break;
        case "tip_show": //提示信息
          tipsNum++;
          renderTipsInfo('', 'tipsInfo','提示信息',tipsResult)
          moreInfo()
          break;
        case "knowledge_show": //医学知识
          tipsNum++;
          renderKnowledgeInfo('','knowledgeInfo','医学知识','点击搜索医学知识')
          break;
        case "scale_show": //全部量表
          tipsNum++;
          renderScaleInfo('','scaleInfo','全部量表','点击搜索全部量表')
          break;
        default:
          break;
      } 
    }
    function bindTab() {
      $('.infoTabBox .infoTab').eq(showTab).addClass('activeTab').siblings().removeClass('activeTab')
      $('.informationBox').eq(showTab).siblings(".informationBox").css({"display":"none"})
      // if(showTab == '1') {
      //     $('.infoTabBox .tipsTab').addClass('activeTab')
      //     $('.infomationBox .treatRecommend').css("display","none")
      // } else {
      //   $('.infoTabBox .treatTab').addClass('activeTab')
      //   $('.infomationBox .tipsInfo').css("display","none")
      //   $('.infomationBox .staticWin').css("display","none")
      // }

      $('.infomationBox .infoTab').click(function() {
        $(this).addClass('activeTab').siblings().removeClass('activeTab')
        $('.informationBox').css("display","none")
        const boxNode = $(this).attr('data-box')
        $('.'+boxNode).css("display","block")
      })
    
    }
    if(tipsNum > 1) {
      bindTab();
    }else if(tipsNum == 0){
      $('.push').css({
        "width":"95%",
        "border-right":"0 none"
      })
      $('.itemAllBox').css({"width":"98%"})
    }
    function moreInfo() {
      $('.moreInfo').click(function(){
        const name = $(this).attr('data-name')
        const type = $(this).attr('data-type')
        openNewWin(`information.html?type=${type}&position=0&name=${name}`)
      })
    }
    
    const pushHei = $('.push').height()
    if(pushHei == 0) {
      $('.infomationBox').css({"width":"90%"})
    }
  
    
  }).catch(function (err) {
    console.log(err);
  })

}
function getVersion() {
  post(config.getVersion, '').then((res) => {
    const data = res.data.data;
    const name = data.name;
    const ver = localStorage.getItem('versionTime-v');
    const time = data.refreshTime;
    if(!ver||ver===time+"=new"||time!==ver.replace("=new","")){       //判断版本是否更新
      $(".version").addClass('new-icon');
      localStorage.setItem('versionTime-v',time+"=new");     //保存版本更新时间
    }else{
      $(".version").removeClass('new-icon');
    }
    $(".version span").html(name);
  })
}
$(function(){
  getVersion();
  //打开版本信息
  $(".disclaimer .version").on("click",function() {
    const ver = localStorage.getItem('versionTime-v');
    $(".version").removeClass('new-icon');
    localStorage.setItem('versionTime-v',ver.replace("=new",""));
    openNewWin("version.html");
  });
 })
