require('./../css/staticSearch.css');
require('./../images/del_nor.png')
var $ = require("jquery");
var { post,config,getUrlArgObject,openNewWin } = require('./promise.js');

var type = getUrlArgObject("type");
$(".staticSearchT input").keyup(function(e) {
    const ev = e||window.event;
    const val = $(this).val();
    const place = $(this).attr("placeholder")
    $(this).parents(".staticSearchT").find("i").css({display:val==""?"none":"inline-block"})
    
    if(place == '量表搜索'){
        if(val == ''){
            $(".searchScale .staticSearchB .empty").css({display:'none'})
            $(".searchScale .staticSearchB .tip").css({display:'none'})
            $(".searchScale .staticSearchB ul").html('')
        }
        ev.keyCode == 13&&getScaleData(val);
    }else if(place == '医学知识搜索'){
        if(val == ''){
            $(".searchKnowledge .staticSearchB .empty").css({display:'none'})
            $(".searchKnowledge .staticSearchB .tip").css({display:'none'})
            $(".searchKnowledge .staticSearchB ul").html('')
        }
        ev.keyCode == 13&&getKnowledgeData(val);
    }
})
if(type == 1){
    document.title = "医学知识搜索"
    $(".searchScale").css({display:'none'})
    $(".searchKnowledge").css({display:'block'})
    $(".searchKnowledge .staticSearchT").on('click','button',function() {
        var val = $(this).parents(".staticSearchT").find("input").val()
        val!=''&&getKnowledgeData(val)
    })
}else if(type == 2){
    document.title = "量表搜索"
    $(".searchKnowledge").css({display:'none'})
    $(".searchScale").css({display:'block'})
    $(".searchScale .staticSearchT").on('click','button',function(e) {
        var val = $(this).parents(".staticSearchT").find("input").val()
        val!=''&&getScaleData(val)
    })
}

function getKnowledgeData(value) {
    post(config.getStaticKnowledge,{
        inputStr: value
        }).then((res) => {
        const data = res.data
        if(data.code == 0) {
            var knowledgeLis = data.data;
            var lisStr = ''
            if(knowledgeLis&&knowledgeLis.length>0){
                for(var i = 0;i<knowledgeLis.length;i++){
                    var tmpPart = knowledgeLis[i]
                    var tmpLi = `<li data-name='${(tmpPart.type==5 ||tmpPart.type==51)?tmpPart.uniqueName:tmpPart.name}' data-type='1' data-sign='${(tmpPart.type==5 ||tmpPart.type==51)?12:tmpPart.type}'>
                        <p>${tmpPart.name}<i>${tmpPart.libTypeName?('( '+tmpPart.libTypeName+' )'):''}</i></p>
                        ${tmpPart.retrievalName?('<span>• '+tmpPart.retrievalName+'</span>'):''}
                    </li>`
                    lisStr += tmpLi
                }
                $(".searchKnowledge .staticSearchB .empty").css({display:'none'})
                $(".searchKnowledge .staticSearchB .tip").css({display:'block'})
                $(".searchKnowledge .staticSearchB ul").html(lisStr)
            }else{
                $(".searchKnowledge .staticSearchB .empty").css({display:'block'})
                $(".searchKnowledge .staticSearchB .tip").css({display:'none'})
                $(".searchKnowledge .staticSearchB ul").html('')
            }
        }else{
            console.log(res)
        }
    })
}
function getScaleData(value) {
    post(config.getStaticScale,{
        filterName: [],
        name: value
    }).then((res) => {
        const data = res.data
        if(data.code == 0) {
            var knowledgeLis = data.data;
            var lisStr = ''
            if(knowledgeLis&&knowledgeLis.length>0){
                for(var i = 0;i<knowledgeLis.length;i++){
                    var tmpPart = knowledgeLis[i]
                    var tmpLi = `<li data-name='${tmpPart.name}' data-type='2'>
                        <p>${tmpPart.name}<i>${tmpPart.libTypeName?('( '+tmpPart.libTypeName+' )'):''}</i></p>
                    </li>`
                    lisStr += tmpLi
                }
                $(".searchScale .staticSearchB ul").html(lisStr)
                $(".searchScale .staticSearchB .empty").css({display:'none'})
                $(".searchScale .staticSearchB .tip").css({display:'block'})
            }else{
                $(".searchScale .staticSearchB .empty").css({display:'block'})
                $(".searchScale .staticSearchB .tip").css({display:'none'})
                $(".searchScale .staticSearchB ul").html('')
            }
        }else{
            console.log(res)
        }
    })
}
function adjustHeight() {
    var ht = window.innerHeight;
    $(".staticSearchB ul").height(ht - 120 + "px");
}
$(window).on('resize', function(){
    adjustHeight()
})

$(".staticSearchB ul").on("click","li",function(){
    const infoMsgName = $(this).attr('data-name')
    const type = $(this).attr('data-type')
    const sign = $(this).attr('data-sign')
    if(type == 1){
        openNewWin(`information.html?type=${sign}&position=0&name=${infoMsgName}`)
    }else{
        let msg = JSON.parse(getUrlArgObject("msg"));
        openNewWin(`scale.html?featureType=21&sex=${msg.sex}&lis=${JSON.stringify(msg.lis)}&diag=${msg.diag}&diseaseName=${msg.diseaseName}&scaleName=${infoMsgName}&symptom=${msg.symptom}&other=${msg.other}&pacs=${msg.pacs}&vital=${msg.vital}&age=${msg.age}`)
    }
})

  
$(".staticSearchT").on('click','#clearKnowledge',function() {
    $(".staticSearchT input").val("")
    $(".searchKnowledge .staticSearchB ul").html('')
    $(".searchKnowledge .staticSearchB .tip").css({display:'none'})
    $(".searchKnowledge .staticSearchB .empty").css({display:'none'})
    $(this).prev('.ipt').find('input').focus()
    $(this).css({display:"none"})
})
$(".staticSearchT").on('click','#clearScale',function() {
    $(".staticSearchT input").val("")
    $(".searchScale .staticSearchB ul").html('')
    $(".searchScale .staticSearchB .tip").css({display:'none'})
    $(".searchScale .staticSearchB .empty").css({display:'none'})
    $(this).prev('.ipt').find('input').focus()
    $(this).css({display:"none"})
})